"use strict";
/*
fly-ff-vkbd-plugin
Version: 1.0.0
Author:  YatmanovDA
Date:    21 Aug 2014
Purpose: A virtual keyboard for Firefox (fly-vkbd)
*/

window.addEventListener("load", function() { ffVkbd.startUp(); }, false);

var ffVkbd = {
    startUp: function()
    {
        var env = Components.classes["@mozilla.org/process/environment;1"].getService(Components.interfaces.nsIEnvironment);
        var session = env.get("DESKTOP_SESSION");
        var enabled = session === "fly-tablet" || session === "fly-mobile";

        if(enabled) {
            this.file = Components.classes["@mozilla.org/file/local;1"]
            .createInstance(Components.interfaces.nsIFile);
            this.file.initWithPath("/usr/bin/fly-vkbd");

            this.opened = false;
            this.focus; // current focused element
            this.focusTimerId = -1;

            document.addEventListener("focus", this.onFocus,true);
            document.addEventListener("blur", this.onFocus,true);
        }
    },
    onFocus: function() {
        if(this.focusTimerId && this.focusTimerId >= 0)
            window.clearTimeout(this.focusTimerId);

        this.focusTimerId = window.setTimeout(ffVkbd.focusFunc, 100);
    },
    focusFunc: function() {
        var process;
        ffVkbd.focus = document.commandDispatcher.focusedElement;
        if(!ffVkbd.focus) ffVkbd.focus = document.commandDispatcher.focusedWindow.document.activeElement;
        // auto open/close
        if (ffVkbd.focus && ffVkbd.focus.getAttribute('data-ffVkbd')!=='false' && (
                    ffVkbd.focus.nodeName && ffVkbd.focus.nodeName.toLowerCase() in {
                        'input':'','select':'',
                        'option':'','textarea':''
                    }
                    ||	ffVkbd.focus.type && ffVkbd.focus.type.toLowerCase() in {
                        'text':'','password':'','url':'','color':'','date':'','datetime':'',
                        'datetime-local':'','email':'','month':'','number':'','range':'',
                        'search':'','tel':'','time':'','week':''
                    }
                    )
                ) {
            //console.log("onFocus(): Show keyboard; opened:", ffVkbd.opened);
            if(!ffVkbd.opened) {
                ffVkbd.opened = true;

                process = Components.classes["@mozilla.org/process/util;1"]
                .createInstance(Components.interfaces.nsIProcess);
                process.init(ffVkbd.file);

                process.runAsync([], 0);
            }
        }
        else {
            //console.log("onFocus(): Hide keyboard; opened:", ffVkbd.opened);
            if(ffVkbd.opened) {
                ffVkbd.opened = false;

                process = Components.classes["@mozilla.org/process/util;1"]
                .createInstance(Components.interfaces.nsIProcess);
                process.init(ffVkbd.file);

                process.runAsync(["--minimizetotray"], 1);
            }
        }
    }
}
// END fly-ff-vkbd-plugin
